unit hiI2C;

interface

uses Kol,Share,Windows,Debug;

type
	THII2C = class(TDebug)
   private
   Nb:integer; //     MISO  
   SDAin:byte; //       
     
   public
    _event_onNext:THI_Event;//   
	_event_onSCL:THI_Event; //  SCL
	_event_onSDA:THI_Event;//  SDA
	_event_onOut_i2c:THI_Event;//   
 	_event_onIndexByte:THI_Event;//   
	_event_onMessErr:THI_Event;	//        
    _data_AdrDev:THI_Event; //   ()
   	_data_DataI2C:THI_Event; //     SDA
    _data_SendI2C:THI_Event; //       
    	
	procedure _work_doRead(var _Data:TData; Index:word); //  , -  
    procedure _work_doWrite(var _Data:TData; Index:word); //  , -  
    procedure _work_doSetAdrDev(var _Data:TData; Index:word);//   
	procedure _work_doSetAdrCell(var _Data:TData; Index:word);//   
	procedure _work_doStart(var _Data:TData; Index:word);//  
	procedure _work_doStop(var _Data:TData; Index:word);//   
	function _work_CheckACK(var _Data:TData): boolean; //   ACK
	procedure SendACK(ACK:integer); //  ACK 
	function _work_ReadI2C(var _Data:TData): byte;//     
    procedure WriteI2C(DatOut:byte); //     (  )
	procedure PulseStart(); //  
	procedure PulseStop(); //     
	procedure _var_DataOutI2C(var _Data:TData; Index:word);	    //      
    property _prop_Nbit:integer write Nb;//      
 
  end;

implementation



//==================================================================================
//================================================================================
procedure THII2C._work_doStart; 
begin
PulseStart(); //   
end;
//==================================================================================
//================================================================================
procedure THII2C._work_doStop; 
begin
PulseStop(); //   
end;
//==================================================================================
//================================================================================
//    
procedure THII2C._work_doSetAdrDev;
var
adr:byte;
b: boolean;                                           
begin
    b := ReadBool(_Data);//    RW
	adr := ReadInteger(_Data,_data_AdrDev);//      2401= 1010000
    adr := adr Shl 1; //       RW( RW=1 RW=0)
	if  b then adr := adr or (1 shl 0);//      1
	if  not b then adr := adr and not (1 shl 0);//      0
	PulseStart(); //   
    WriteI2C(adr); //     RW
	if _work_CheckACK(_Data) then _hi_onEvent(_event_onMessErr, '  ACK');
    _hi_onEvent(_event_onNext, 1); //   
end;
//==============================================================================
//==============================================================================
//==============================================================================
//    
procedure THII2C._work_doSetAdrCell;
var
adr,i:byte;
                                  
begin
    i := ToInteger(_Data);//     
	adr := ReadInteger(_Data,_data_AdrDev);//      2401= 1010000
    adr := adr Shl 1; //       RW( RW=1 RW=0)
	adr := adr and not (1 shl 0);//    
	PulseStart(); //   
    WriteI2C(adr); //     RW
	if _work_CheckACK(_Data) then _hi_onEvent(_event_onMessErr, '  ACK');
    WriteI2C(i); //   
	if _work_CheckACK(_Data) then _hi_onEvent(_event_onMessErr, '  ACK');
	_hi_onEvent(_event_onNext, 1); //   
end;
//==============================================================================
//==============================================================================
//WWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWW
procedure THII2C._work_doWrite; //        LSB MSB
var z,i:integer;
SDA:byte;
begin
	 i := ToInteger(_Data);//    -   
	 for z := 1 to i do  //    , -  
          begin
		  _hi_onEvent(_event_onIndexByte, z);
		  SDA := ReadInteger(_Data,_data_SendI2C);//   
		  WriteI2C(SDA);//  
	      if _work_CheckACK(_Data) then _hi_onEvent(_event_onMessErr, '  ACK');//   ACK
		  _hi_onEvent(_event_onSDA, 1);
		  
		  
		  end;      
		  _hi_onEvent(_event_onNext, 1);//   
end;
//==============================================================================
//==============================================================================
//RRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRR
procedure THII2C._work_doRead;
var z,i:integer;
adr:byte;
begin
	 i := ToInteger(_Data);//       
	 for z := 1 to i do  //    , -  
          begin
		  SDAin := _work_ReadI2C(_Data);//       SDAin
		  if z=i then SendACK(1) //  ACK ACK=0 NACK=1
          else  SendACK(0); //  ACK ACK=0 NACK=1
		  _hi_onEvent(_event_onIndexByte, z);
		  _hi_onEvent(_event_onOut_i2c, SDAin);
		  end;    
_hi_onEvent(_event_onNext, 1);
end;
//====================================================================
procedure THII2C.SendACK;
begin
_hi_onEvent(_event_onSDA, ACK);
_hi_onEvent(_event_onSCL, 1);
_hi_onEvent(_event_onSCL, 0);
_hi_onEvent(_event_onSDA, 1);
end;
//==========================================================================
function THII2C._work_CheckACK;
var SDA:byte;
begin
_hi_onEvent(_event_onSCL, 1);
SDA := ReadInteger(_Data,_data_DataI2C);//       ACK
if SDA and (1 shl Nb) <> 0 then Result:=true;
if SDA and (1 shl Nb) = 0 then Result:=false;	
_hi_onEvent(_event_onSCL, 0);
end;
//====================================================================
procedure THII2C.PulseStart;
begin
_hi_onEvent(_event_onSDA, 1);
_hi_onEvent(_event_onSCL, 1);
_hi_onEvent(_event_onSDA, 0);
_hi_onEvent(_event_onSCL, 0);
end;
//====================================================================
procedure THII2C.PulseStop;
begin
_hi_onEvent(_event_onSDA, 0);
_hi_onEvent(_event_onSCL, 0);
_hi_onEvent(_event_onSCL, 1);
_hi_onEvent(_event_onSDA, 1);
end;
//====== WRITE I2C =============================================================
procedure THII2C.WriteI2C; 
var i:integer;
begin
	 for i := 0 to 7 do  //    
	 	 begin //   
         if DatOut and (1 shl (7-i)) <> 0 then _hi_onEvent(_event_onSDA, 1);// 7-i    
         if DatOut and (1 shl (7-i)) = 0 then _hi_onEvent(_event_onSDA, 0);	      		
		 _hi_onEvent(_event_onSCL, 1);
	     _hi_onEvent(_event_onSCL, 0);
	     end;    
end;
//==============================================================================
//====== READ I2C ==============================================================
function THII2C._work_ReadI2C;
var i:integer;
RX,In_i2c:byte;
begin
	 for i := 0 to 7 do  //    
	 	 begin //   
         _hi_onEvent(_event_onSDA, 1);
		 _hi_onEvent(_event_onSCL, 1);
          In_i2c := ReadInteger(_Data,_data_DataI2C);//       SDA
		 if In_i2c and (1 shl Nb) <> 0 then RX := RX or (1 shl (7-i));
         if In_i2c and (1 shl Nb) = 0 then RX := RX and not (1 shl (7-i));
         _hi_onEvent(_event_onSCL, 0);     
         end;
Result:= RX;
end;
//==============================================================================
//==============================================================================
procedure THII2C._var_DataOutI2C;
begin 
dtInteger(_Data,SDAin);
end;   
//==============================================================================

end.